def print_matrix(m, maxord):
	# stampa la matrice dall'alto verso il basso */
	r = maxord
	c = 0
	
	while r >= 0:

		for c in range(0, 128):
			# evito di stampare le colonne vuote..
			if m[0][c] != ' ':
				print(m[r][c], end="")
			
		r = r - 1
		print("") # a capo
		
	for i in range(0, 128):
		if m[0][i] != ' ':
			print(chr(i), end="")
	print("")

def istover(astring):
	maxrows = len(astring)
	maxcols = 128 # numero di caratteri ASCII standard
	maxord = 0 # massimo valore assunto dalle "ordinate"
	
	# creo e popolo la matrice di soli spazi
	matrix = []
	row = []
	# preparo una riga di maxcols elementi
	for c in range(0, maxcols):
		row.append(' ')
	
	# inserisco maxrows righe uguali a row
	# NOTA BENE!! devo fare una copia di row ogni volta
	# prima di passarlo ad append perche' python passa i
	# parametri per OBJECT REFERENCE, quindi ogni cambiamento
	# su un vettore riga si ripercuoterebbe su tutte le righe!
	#
	for r in range(0, maxrows):
		matrix.append(row[:])
		
	
	for i in range(0, len(astring)):
		
		r = 0 # indice di riga
		
		caratt = ord(astring[i])
		
		# salto gli elementi che hanno gia' un '*' 
		# sulla colonna corrispondente al carattere
		# caratt e sulla riga r
		
		# perche' maxrows - 1 ??
		while (r < maxrows - 1) and (matrix[r][caratt] != ' '):
			r = r + 1
		
		matrix[r][caratt] = '*'
		if maxord < r:
			maxord = r # salvo il valore massimo assunto dalle ordinate
		
	print_matrix(matrix, maxord)		
	
	
